#ifdef OPENGL_ES
#extension GL_OES_standard_derivatives : enable
#ifdef GL_FRAGMENT_PRECISION_HIGH
precision highp float;
#else
precision mediump float;
#endif
#else
precision mediump float;
#endif

///////////////////////////////////////////////////////////
// Uniforms
uniform float u_time;
uniform vec3 u_resolution;	// ӁIdlIvec2Ȃ̂vec3őp
///////////////////////////////////////////////////////////
// Varyings
varying vec2 v_texCoord;

mat2 rot(float a)
{
	float c = cos(a);
	float s = sin(a);
	return mat2(c, s, -s, c);
}

const float pi = 3.141592;//acos(-1.0);
const float pi2 = pi * 2.0;

// sU
vec2 pmod(vec2 p, float r)
{
	float a =  atan(p.x, p.y) + pi / r;
	float n = pi2 / r;
	a = floor(a / n) * n;
	return p * rot(-a);
}

void main()
{
	// ʒ̍Wɕϊ
	vec2 p = (gl_FragCoord.xy * 2.0 - u_resolution.xy) / u_resolution.y;

	p = pmod(p, abs(sin(u_time) * 8.0) + 8.0);

	float t = u_time * 1.5;
	float r = sin(t);
	float g = cos(t);
	float b = atan(r, g);

	vec3 c = 0.07 / length(vec2(0.04, 2.0 * p.y - 1.0 + sin(p.x * 10.0 + u_time * 4.0))) * vec3(abs(r - 1.0), abs(g), abs(b));
	c += 0.06 / length(vec2(0.06, 3.0 * p.y - 1.0 + sin(p.x * 10.0 + u_time * 6.0))) * vec3(abs(r), abs(g - 1.0), abs(b));
	c += 0.05 / length(vec2(0.10, 5.0 * p.y - 1.0 + sin(p.x * 10.0 + u_time * 10.0))) * vec3(abs(r), abs(g), abs(b - 1.0));

	gl_FragColor = vec4(c, 1.0);

}
